#Module-Specific definitions
%define mod_version 1.8.7
%define mod_name mod_security
%define mod_conf 82_%{mod_name}.conf
%define mod_so %{mod_name}.so
%define sourcename %{mod_name}-%{mod_version}

%define apache_version 2.0.53

# Standard Module Definitions
%define name apache2-%{mod_name}
%define version %{apache_version}_%{mod_version}

Summary:	Mod_security is a DSO module for the apache2 Web server
Name:		%{name}
Version:	%{version}
Release:	%mkrel 2
Group:		System/Servers
License:	GPL
URL:		http://www.modsecurity.org/
Source0:	%{sourcename}.tar.bz2
Source1:	%{mod_conf}.bz2
# wget http://www.snort.org/dl/rules/snortrules-snapshot-CURRENT.tar.gz
Source2:	snortrules-snapshot-CURRENT.tar.bz2
# (fc) 1.8.7-1mdk fix some snort rules
Patch0:		mod_security-1.8.7-fixsnortrules.patch.bz2
Prereq:		rpm-helper
Prereq:		apache2 >= %{apache_version}
Prereq:		apache2-conf
BuildRequires:	apache2-devel >= %{apache_version}-1mdk
BuildRequires:	file
BuildRoot:	%{_tmppath}/%{name}-buildroot

%description
ModSecurity is an open source intrustion detection and prevention
engine for web applications. It operates embedded into the web
server, acting as a powerful umbrella - shielding applications
from attacks.

%prep

%setup -q -n modsecurity-%{mod_version}

tar -jxf %SOURCE2

%patch0 -p1 -b .fixsnortrules

cat > mod_security-snortrules.conf << EOF
# This file was generated using the %{_sbindir}/snort2modsec.pl perl script.

EOF
perl util/snort2modsec.pl rules/web*.rules >> mod_security-snortrules.conf

# strip away annoying ^M
find . -type f|xargs file|grep 'CRLF'|cut -d: -f1|xargs perl -p -i -e 's/\r//'
find . -type f|xargs file|grep 'text'|cut -d: -f1|xargs perl -p -i -e 's/\r//'

%build
cp apache2/%{mod_name}.c .
%{_sbindir}/apxs2 -c %{mod_name}.c

%install
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

install -d %{buildroot}%{_libdir}/apache2-extramodules
install -d %{buildroot}%{_sysconfdir}/httpd/conf.d

install -m0755 .libs/*.so %{buildroot}%{_libdir}/apache2-extramodules/
bzcat %{SOURCE1} > %{buildroot}%{_sysconfdir}/httpd/conf.d/%{mod_conf}

install -d %{buildroot}%{_var}/www/html/addon-modules
ln -s ../../../..%{_docdir}/%{name}-%{version} %{buildroot}%{_var}/www/html/addon-modules/%{name}-%{version}

install -d %{buildroot}%{_sbindir}
install -d %{buildroot}%{_sysconfdir}/httpd/2.0/conf

install -m0755 util/snort2modsec.pl %{buildroot}%{_sbindir}/
install -m0644 mod_security-snortrules.conf %{buildroot}%{_sysconfdir}/httpd/2.0/conf/

%post
if [ -f %{_var}/lock/subsys/httpd ]; then
    %{_initrddir}/httpd restart 1>&2;
fi

%postun
if [ "$1" = "0" ]; then
    if [ -f %{_var}/lock/subsys/httpd ]; then
	%{_initrddir}/httpd restart 1>&2
    fi
fi

%clean
[ "%{buildroot}" != "/" ] && rm -rf %{buildroot}

%files
%defattr(-,root,root)
%doc tests CHANGES README httpd.conf* modsecurity-manual*.pdf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/2.0/conf/mod_security-snortrules.conf
%attr(0644,root,root) %config(noreplace) %{_sysconfdir}/httpd/conf.d/%{mod_conf}
%attr(0755,root,root) %{_libdir}/apache2-extramodules/%{mod_so}
%{_var}/www/html/addon-modules/*
%attr(0755,root,root) %{_sbindir}/snort2modsec.pl

%changelog
* Sun Mar 20 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_1.8.7-2mdk
- use the %%mkrel macro

* Tue Mar 15 2005 Frederic Crozat <fcrozat@mandrakesoft.com> 2.0.53_1.8.7-1mdk 
- Release 1.8.7
- Fix default config file to have a working server
- Patch0: fix some snort rules

* Mon Feb 28 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_1.8.6-3mdk
- fix %%post and %%postun to prevent double restarts
- fix bug #6574

* Wed Feb 16 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_1.8.6-2mdk
- spec file cleanups, remove the ADVX-build stuff

* Tue Feb  8 2005 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.53_1.8.6-1mdk
- rebuilt for apache 2.0.53

* Tue Nov 09 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.52_1.8.6-1mdk
- rebuilt for apache 2.0.52

* Fri Nov 05 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.50_1.8.6-1mdk
- 1.8.6

* Wed Oct 27 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.50_1.8.5-1mdk
- 1.8.5

* Thu Jul 29 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.50_1.8.4-1mdk
- 1.8.4

* Mon Jul 12 2004 Oden Eriksson <oeriksson@mandrakesoft.com> 2.0.50_1.8.3-1mdk
- 1.8.3
- built for apache 2.0.50
- remove redundant provides

* Tue Jun 22 2004 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.49_1.8.2-1mdk
- 1.8.2

* Mon Jun 14 2004 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.49_1.7.6-1mdk
- built for apache 2.0.49

* Tue Mar 23 2004 Michael Scherer <misc@mandrake.org> 2.0.48_1.7.6-1mdk
- 1.7.6
- remove auto downloading of the rules
 
* Sun Dec 07 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.48_1.7.4-1mdk
- 1.7.4

* Wed Nov 12 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_1.7.3-1mdk
- 1.7.3

* Wed Nov 05 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.48_1.7.2-1mdk
- built for apache 2.0.48

* Sun Nov 02 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_1.7.2-1mdk
- 1.7.2

* Tue Oct 21 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_1.7.1-1mdk
- 1.7.1
- drop S2, it's included

* Sun Oct 19 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_1.7-1mdk
- 1.7
- added S2 and some spec file magic

* Sun Sep 28 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_1.6-1mdk
- 1.6

* Thu Jul 10 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.47_1.5.1-1mdk
- 1.5.1
- rebuilt against latest apache2, requires and buildrequires
- misc spec file fixes
- updated S1

* Fri Jun 06 2003 Oden Eriksson <oden.eriksson@kvikkjokk.net> 2.0.46_1.5-1mdk
- initial cooker contrib
